<?php

//Get Dir Listings
function get_dir_listings($path) {
	$listings = array();
	if(is_dir($path)) {
		if($handle = opendir($path)) {
			while(($file = readdir($handle)) !== false) {
				if(trim($file) !== "." && trim($file) !== "..") {
					if(is_dir($path.$file)) $listings[] = $file;
				}
			}
			closedir($handle);
		}
	} else die("NOT A DIRECTORY");
	return $listings;
}

//Get Dir Size, Thanks to: http://aidanlister.com/repos/v/function.dirsize.php
function get_dir_size($path) {
    // Init
    $size = 0;
 
    // Trailing slash
    if (mb_substr($path, -1, 1) !== DIRECTORY_SEPARATOR) {
        $path .= DIRECTORY_SEPARATOR;
    }
 
    // Sanity check
    if (is_file($path)) {
        return filesize($path);
    } elseif (!is_dir($path)) {
        return false;
    }
 
    // Iterate queue
    $queue = array($path);
    for ($i = 0, $j = count($queue); $i < $j; ++$i)
    {
        // Open directory
        $parent = $i;
        if (is_dir($queue[$i]) && $dir = @dir($queue[$i])) {
            $subdirs = array();
            while (false !== ($entry = $dir->read())) {
                // Skip pointers
                if ($entry == '.' || $entry == '..') {
                    continue;
                }
 
                // Get list of directories or filesizes
                $path = $queue[$i] . $entry;
                if (is_dir($path)) {
                    $path .= DIRECTORY_SEPARATOR;
                    $subdirs[] = $path;
                } elseif (is_file($path)) {
                    $size += filesize($path);
                }
            }
 
            // Add subdirectories to start of queue
            unset($queue[0]);
            $queue = array_merge($subdirs, $queue);
 
            // Recalculate stack size
            $i = -1;
            $j = count($queue);
 
            // Clean up
            $dir->close();
            unset($dir);
        }
    }
 
    return $size;
}

function deleteDir($dir) {
   $dhandle = opendir($dir);
   if ($dhandle) {
      while (false !== ($fname = readdir($dhandle))) {
         if (is_dir( "{$dir}/{$fname}" )) {
            if (($fname != '.') && ($fname != '..')) {
               deleteDir("$dir/$fname");
            }
         } else {
            unlink("{$dir}/{$fname}");
         }
      }
      closedir($dhandle);
    }
   rmdir($dir);
}

function emptyDir($dir) {
   $dhandle = opendir($dir);
   if ($dhandle) {
      while (false !== ($fname = readdir($dhandle))) {
         if (is_dir( "{$dir}/{$fname}" )) {
            if (($fname != '.') && ($fname != '..')) {
               deleteDir("$dir/$fname");
            }
         } else {
            unlink("{$dir}/{$fname}");
         }
      }
      closedir($dhandle);
    }
}

function copyDir($new, $old) {
	if(!mkdir($new, 0777)) {
		if(is_dir($new)) die("$new already exists in that location");
		else die("Couldn't make directory $new");
	} else {
		if($handle = opendir($old)) {
			while(($file = readdir($handle)) !== false) {
				if(trim($file) !== "." && trim($file) !== "..") {
					$sourcefile = $old.$file;
					$newfile = $new.$file;
					if(is_dir($sourcefile)) copyDir($newfile."/", $sourcefile."/");
					else(copy($sourcefile, $newfile));
				}
			}
			closedir($handle);
		} else die("Error opening directory $old");
	}
}


?>